﻿using System;
using System.Windows;
using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Prism.UnityExtensions;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Prism.Events;

namespace Sample
{
    public class Bootstrapper : UnityBootstrapper
    {

        // Prism Step 0 - Bootstrapper constructor
        public Bootstrapper()
        {
            try
            {
                base.Run();
            }
            catch (Exception ex) { throw ex; }
        }

        // Prism Step 1 - Create LoggerFacade
        //protected override Microsoft.Practices.Prism.Logging.ILoggerFacade CreateLogger()
        //{
            
        //}


        // Prism Step 2 - Create and configure Module catalog
        protected override Microsoft.Practices.Prism.Modularity.IModuleCatalog CreateModuleCatalog()
        {
            try
            {
                ModuleCatalog catalog = new ConfigurationModuleCatalog();
                return catalog;
            }
            catch (Exception ex) { throw ex; }
        }


        // Prism Step 3 - Create and configure Container
        protected override void ConfigureContainer()
        {
            try
            {
                Container.RegisterType<IShellView, ShellView>(new ContainerControlledLifetimeManager());
                Container.RegisterType<IShellViewModel, ShellViewModel>(new ContainerControlledLifetimeManager());

                Container.RegisterType<ISampleGridView, SampleGridView>();
                Container.RegisterType<ISampleGridViewModel, SampleGridViewModel>();
                

                base.ConfigureContainer();                                
            }
            catch (Exception ex) { throw ex; }
        }


        // Prism Step 4 - Create the Shell
        protected override System.Windows.DependencyObject CreateShell()
        {
            try
            {
                IShellViewModel viewModel = Container.Resolve<IShellViewModel>();
                IShellView view = viewModel.View;
                view.ShowView();

                return view as DependencyObject;
            }
            catch (Exception ex) { throw ex; }
        }


        // Prism Step 5 - Initialize the modules
        protected override void InitializeModules()
        {
            try
            {
                base.InitializeModules();
            }
            catch (Exception ex) { throw ex; }
        }

    }
}
