using System;
using System.Windows;
using Microsoft.Practices.Prism.Events;
using Microsoft.Practices.Prism.Commands;
using Microsoft.Practices.Prism.Regions;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Threading;
using System.Windows.Controls;


namespace Sample
{
    public class SampleGridViewModel : DependencyObject, ISampleGridViewModel
    {
        private readonly IEventAggregator eventAggregator;
        private readonly IRegionManager regionManager;

        public ObservableCollection<DumpObject> data { get; set; }

        public SampleGridViewModel(ISampleGridView view, IEventAggregator eventAggregator, IRegionManager regionManager, int row)
        {
            this.View = view;            
            this.View.SetViewModel(this);

            this.eventAggregator = eventAggregator;
            this.regionManager = regionManager;
            
            this.View.ViewName = string.Format("SampleGrid {0}", Guid.NewGuid());

            ///fakes data
            this.data = new ObservableCollection<DumpObject>(MockData.GetDumpData(row));
        }
        
        #region ISampleGridViewModel Members

        public ISampleGridView View { get; private set; }
        
        #endregion
                
    }
}
